/*
 * (c) Copyright 2001
 * Peter Blum, Peter.Blum@readme1st.de
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */


#ifndef _DECODER_H
#define _DEOCDER_H

#include <sys/types.h>

#include "device.h"

#define	BYTE		0xff            /* byte mask */
#define	WORD		0xffff        	/* word mask */
#define	LONG		0xffffffff	/* long mask */

/* Address decoder Functions */
extern int  decoderInit(void);
extern int  decoderReset(void);

/* Called to poll input and maintain timer devices */
extern void decCycle(void);

/* Memory access functions */
extern int  memWrite(u_long loc, u_long size, u_long data);
extern int  memRead(u_long loc, u_long size, u_long *result);

/* Interrupt Functions */
extern int  intAcknowledge(int level);
extern void intSetIRQ(Device *dev);
extern void intClearIRQ(Device *dev);

#endif
